Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -20,103 +20,111 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! - vector branch further optimized (linear dependencies along z removed and
+!   loops are splitted)
+! - topography closed channel flow with symmetric boundaries also implemented
+!   in vector branch
+! - some formatting adjustments made and comments added
+! - cpu measures for vector branch added
+!
+! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
-! 
+!
 ! 4414 2020-02-19 20:16:04Z suehring
 ! Move call for initialization of control flags to ws_init
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
-! 
+!
 ! 4340 2019-12-16 08:17:03Z Giersch
-! Topography closed channel flow with symmetric boundaries implemented 
-! 
+! Topography closed channel flow with symmetric boundaries implemented
+!
 ! 4330 2019-12-10 16:16:33Z knoop
 ! Bugix: removed syntax error introduced by last commit
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4328 2019-12-09 18:53:04Z suehring
 ! Minor formatting adjustments
-! 
+!
 ! 4327 2019-12-06 14:48:31Z Giersch
 ! Setting of advection flags for vertical fluxes of w revised, air density for
 ! vertical flux calculation of w at k=1 is considered now
-! 
+!
 ! 4325 2019-12-06 07:14:04Z Giersch
-! Vertical fluxes of w are now set to zero at nzt and nzt+1, setting of 
+! Vertical fluxes of w are now set to zero at nzt and nzt+1, setting of
 ! advection flags for fluxes in z-direction revised, comments extended
-! 
+!
 ! 4324 2019-12-06 07:11:33Z Giersch
 ! Indirect indexing for calculating vertical fluxes close to boundaries is only
 ! used for loop indizes where it is really necessary
-! 
+!
 ! 4317 2019-12-03 12:43:22Z Giersch
-! Comments revised/added, formatting improved, fluxes for u,v, and scalars are 
+! Comments revised/added, formatting improved, fluxes for u,v, and scalars are
 ! explicitly set to zero at nzt+1, fluxes of w-component are now calculated only
 ! until nzt-1 (Prognostic equation for w-velocity component ends at nzt-1)
-! 
+!
 ! 4204 2019-08-30 12:30:17Z knoop
 ! Bugfix: Changed sk_num initialization default to avoid implicit SAVE-Attribut
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4110 2019-07-22 17:05:21Z suehring
 ! - Separate initialization of advection flags for momentum and scalars. In this
-!   context, resort the bits and do some minor formatting. 
-! - Make flag initialization for scalars more flexible, introduce an 
-!   arguemnt list to indicate non-cyclic boundaries (required for decycled 
+!   context, resort the bits and do some minor formatting.
+! - Make flag initialization for scalars more flexible, introduce an
+!   arguemnt list to indicate non-cyclic boundaries (required for decycled
 !   scalars such as chemical species or aerosols)
-! - Introduce extended 'degradation zones', where horizontal advection of 
-!   passive scalars is discretized by first-order scheme at all grid points 
-!   that in the vicinity of buildings (<= 3 grid points). Even though no 
-!   building is within the numerical stencil, first-order scheme is used. 
+! - Introduce extended 'degradation zones', where horizontal advection of
+!   passive scalars is discretized by first-order scheme at all grid points
+!   that in the vicinity of buildings (<= 3 grid points). Even though no
+!   building is within the numerical stencil, first-order scheme is used.
 !   At fourth and fifth grid point the order of the horizontal advection scheme
 !   is successively upgraded.
-!   These extended degradation zones are used to avoid stationary numerical 
+!   These extended degradation zones are used to avoid stationary numerical
 !   oscillations, which are responsible for high concentration maxima that may
-!   appear under shear-free stable conditions. 
-! - Change interface for scalar advection routine. 
+!   appear under shear-free stable conditions.
+! - Change interface for scalar advection routine.
 ! - Bugfix, avoid uninitialized value sk_num in vector version of scalar
 !   advection
-! 
+!
 ! 4109 2019-07-22 17:00:34Z suehring
-! Implementation of a flux limiter according to Skamarock (2006) for the 
-! vertical scalar advection. Please note, this is only implemented for the 
+! Implementation of a flux limiter according to Skamarock (2006) for the
+! vertical scalar advection. Please note, this is only implemented for the
 ! cache-optimized version at the moment. Implementation for the vector-
-! optimized version will follow after critical issues concerning 
+! optimized version will follow after critical issues concerning
 ! vectorization are fixed.
-! 
+!
 ! 3873 2019-04-08 15:44:30Z knoop
 ! Moved ocean_mode specific code to ocean_mod
-! 
+!
 ! 3872 2019-04-08 15:03:06Z knoop
 ! Moved all USE statements to module level + removed salsa dependency
-! 
+!
 ! 3871 2019-04-08 14:38:39Z knoop
 ! Moving initialization of bcm specific flux arrays into bulk_cloud_model_mod
-! 
+!
 ! 3864 2019-04-05 09:01:56Z monakurppa
 ! Remove tailing white spaces
-! 
+!
 ! 3696 2019-01-24 16:37:35Z suehring
 ! Bugfix in degradation height
-! 
+!
 ! 3661 2019-01-08 18:22:50Z suehring
-! - Minor bugfix in divergence correction (only has implications at 
+! - Minor bugfix in divergence correction (only has implications at
 !   downward-facing wall surfaces)
 ! - Remove setting of Neumann condition for horizontal velocity variances
 ! - Split loops for tendency calculation and divergence correction in order to
 !   reduce bit queries
-! - Introduce new parameter nzb_max_l to better control order degradation at 
+! - Introduce new parameter nzb_max_l to better control order degradation at
 !   non-cyclic boundaries
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! OpenACC port for SPEC
@@ -133,6 +141,6 @@
 ! ------------
 !> Advection scheme for scalars and momentum using the flux formulation of
-!> Wicker and Skamarock 5th order. Additionally the module contains of a 
-!> routine using for initialisation and steering of the statical evaluation. 
+!> Wicker and Skamarock 5th order. Additionally the module contains of a
+!> routine using for initialisation and steering of the statical evaluation.
 !> The computation of turbulent fluxes takes place inside the advection
 !> routines.
@@ -140,6 +148,6 @@
 !> degraded.
 !> A divergence correction is applied. It is necessary for topography, since
-!> the divergence is not sufficiently reduced, resulting in erroneous fluxes 
-!> and could lead to numerical instabilities. 
+!> the divergence is not sufficiently reduced, resulting in erroneous fluxes
+!> and could lead to numerical instabilities.
 !>
 !> @todo Implement monotonic flux limiter also for vector version.
@@ -154,15 +162,14 @@
                u_stokes_zu, v_stokes_zu,                                       &
                diss_l_diss, diss_l_e, diss_l_pt, diss_l_q,                     &
-               diss_l_s, diss_l_sa, diss_l_u, diss_l_v, diss_l_w,              &
+               diss_l_s, diss_l_u, diss_l_v, diss_l_w,                         &
                flux_l_diss, flux_l_e, flux_l_pt, flux_l_q, flux_l_s,           &
-               flux_l_sa, flux_l_u, flux_l_v, flux_l_w,                        &
+               flux_l_u, flux_l_v, flux_l_w,                                   &
                diss_s_diss, diss_s_e, diss_s_pt, diss_s_q, diss_s_s,           &
-               diss_s_sa, diss_s_u, diss_s_v, diss_s_w,                        &
+               diss_s_u, diss_s_v, diss_s_w,                                   &
                flux_s_diss, flux_s_e, flux_s_pt, flux_s_q, flux_s_s,           &
-               flux_s_sa, flux_s_u, flux_s_v, flux_s_w
+               flux_s_u, flux_s_v, flux_s_w
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry,                                                  &
-               bc_dirichlet_l,                                                 &
+        ONLY:  bc_dirichlet_l,                                                 &
                bc_dirichlet_n,                                                 &
                bc_dirichlet_r,                                                 &
@@ -176,7 +183,4 @@
                passive_scalar,                                                 &
                rans_tke_e,                                                     &
-               momentum_advec,                                                 &
-               salsa,                                                          &
-               scalar_advec,                                                   &
                symmetry_flag,                                                  &
                intermediate_timestep_count,                                    &
@@ -186,4 +190,8 @@
                ws_scheme_sca,                                                  &
                dt_3d
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log,                                                        &
+               log_point_s
 
     USE exchange_horiz_mod,                                                    &
@@ -198,9 +206,9 @@
                nxlg,                                                           &
                nxlu,                                                           &
-               nxr,                                                            & 
-               nxrg,                                                           & 
+               nxr,                                                            &
+               nxrg,                                                           &
                ny,                                                             &
-               nyn,                                                            & 
-               nyng,                                                           & 
+               nyn,                                                            &
+               nyng,                                                           &
                nys,                                                            &
                nysg,                                                           &
@@ -242,10 +250,10 @@
     INTERFACE ws_init
        MODULE PROCEDURE ws_init
-    END INTERFACE ws_init         
-             
+    END INTERFACE ws_init
+
     INTERFACE ws_init_flags_momentum
        MODULE PROCEDURE ws_init_flags_momentum
     END INTERFACE ws_init_flags_momentum
-    
+
     INTERFACE ws_init_flags_scalar
        MODULE PROCEDURE ws_init_flags_scalar
@@ -287,5 +295,5 @@
 
 !
-!--    Set the appropriate factors for scalar and momentum advection.
+!--    Set factors for scalar and momentum advection.
        adv_sca_5 = 1.0_wp /  60.0_wp
        adv_sca_3 = 1.0_wp /  12.0_wp
@@ -294,5 +302,5 @@
        adv_mom_3 = 1.0_wp /  24.0_wp
        adv_mom_1 = 1.0_wp /   4.0_wp
-!         
+!
 !--    Arrays needed for statical evaluation of fluxes.
        IF ( ws_scheme_mom )  THEN
@@ -330,27 +338,25 @@
 
 !
-!--    Arrays needed for reasons of speed optimization for cache version.
-!--    For the vector version the buffer arrays are not necessary,
-!--    because the the fluxes can swapped directly inside the loops of the 
-!--    advection routines.
+!--    Arrays needed for reasons of speed optimization
+       IF ( ws_scheme_mom )  THEN
+
+          ALLOCATE( flux_s_u(nzb+1:nzt,0:threads_per_task-1),               &
+                    flux_s_v(nzb+1:nzt,0:threads_per_task-1),               &
+                    flux_s_w(nzb+1:nzt,0:threads_per_task-1),               &
+                    diss_s_u(nzb+1:nzt,0:threads_per_task-1),               &
+                    diss_s_v(nzb+1:nzt,0:threads_per_task-1),               &
+                    diss_s_w(nzb+1:nzt,0:threads_per_task-1) )
+          ALLOCATE( flux_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                    flux_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                    flux_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                    diss_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                    diss_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
+                    diss_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
+
+       ENDIF
+!
+!--    For the vector version the buffer arrays for scalars are not necessary,
+!--    since internal arrays are used in the vector version.
        IF ( loop_optimization /= 'vector' )  THEN
-
-          IF ( ws_scheme_mom )  THEN
-
-             ALLOCATE( flux_s_u(nzb+1:nzt,0:threads_per_task-1),               &
-                       flux_s_v(nzb+1:nzt,0:threads_per_task-1),               &
-                       flux_s_w(nzb+1:nzt,0:threads_per_task-1),               &
-                       diss_s_u(nzb+1:nzt,0:threads_per_task-1),               &
-                       diss_s_v(nzb+1:nzt,0:threads_per_task-1),               &
-                       diss_s_w(nzb+1:nzt,0:threads_per_task-1) )
-             ALLOCATE( flux_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
-                       flux_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
-                       flux_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
-                       diss_l_u(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
-                       diss_l_v(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
-                       diss_l_w(nzb+1:nzt,nys:nyn,0:threads_per_task-1) )
-
-          ENDIF
-
           IF ( ws_scheme_sca )  THEN
 
@@ -358,5 +364,5 @@
                        flux_s_e(nzb+1:nzt,0:threads_per_task-1),               &
                        diss_s_pt(nzb+1:nzt,0:threads_per_task-1),              &
-                       diss_s_e(nzb+1:nzt,0:threads_per_task-1) ) 
+                       diss_s_e(nzb+1:nzt,0:threads_per_task-1) )
              ALLOCATE( flux_l_pt(nzb+1:nzt,nys:nyn,0:threads_per_task-1),      &
                        flux_l_e(nzb+1:nzt,nys:nyn,0:threads_per_task-1),       &
@@ -386,8 +392,7 @@
 
           ENDIF
-
        ENDIF
 !
-!--    Initialize the flag arrays controlling degradation near walls, i.e. 
+!--    Initialize the flag arrays controlling degradation near walls, i.e.
 !--    to decrease the numerical stencil appropriately. The order of the scheme
 !--    is degraded near solid walls as well as near non-cyclic inflow and outflow
@@ -412,5 +417,5 @@
 !> Initialization of flags to control the order of the advection scheme near
 !> solid walls and non-cyclic inflow boundaries, where the order is sucessively
-!> degraded. 
+!> degraded.
 !------------------------------------------------------------------------------!
     SUBROUTINE ws_init_flags_momentum
@@ -437,9 +442,9 @@
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-!  
-!--             At first, set flags to WS1. 
-!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!
+!--             At first, set flags to WS1.
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to
 !--             in order to handle the left/south flux.
-!--             near vertical walls. 
+!--             near vertical walls.
                 advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )
                 advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )
@@ -452,6 +457,6 @@
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
                            .AND. i == nxr   ) )                                &
-                THEN                                                           
-                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )      
+                THEN
+                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),1)  .AND.   &
                                  BTEST(wall_flags_total_0(k,j,i+1),1)  .OR.    &
@@ -462,21 +467,21 @@
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i == nxlu+1) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 1 )       
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
-                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),1)  .AND.          &
-                         BTEST(wall_flags_total_0(k,j,i+2),1)  .AND.          &
-                         BTEST(wall_flags_total_0(k,j,i-1),1) )               &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 2 )       
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
-                ENDIF                                                          
-!                                                                              
-!--             u component - y-direction                                      
-!--             WS1 (3), WS3 (4), WS5 (5)                                       
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 1 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),1)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i+2),1)  .AND.           &
+                         BTEST(wall_flags_total_0(k,j,i-1),1) )                &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 2 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )
+                ENDIF
+!
+!--             u component - y-direction
+!--             WS1 (3), WS3 (4), WS5 (5)
                 IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),1)   .OR.         &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
@@ -484,6 +489,6 @@
                          ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
                            .AND. j == nyn   ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )       
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),1)  .AND.   &
                                  BTEST(wall_flags_total_0(k,j+1,i),1)  .OR.    &
@@ -494,67 +499,67 @@
                          ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
                            .AND. j == nyn-1 ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 4 )       
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 4 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )
                 ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),1)  .AND.          &
                          BTEST(wall_flags_total_0(k,j+2,i),1)  .AND.          &
                          BTEST(wall_flags_total_0(k,j-1,i),1) )               &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 5 )       
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
-                ENDIF                                                          
-!                                                                              
-!--             u component - z-direction. Fluxes are calculated on w-grid                                      
-!--             level. Boundary u-values at/within walls aren't used. 
-!--             WS1 (6), WS3 (7), WS5 (8)                                      
-                IF ( k == nzb+1 )  THEN                                        
-                   k_mm = nzb                                                  
-                ELSE                                                           
-                   k_mm = k - 2                                                
-                ENDIF                                                          
-                IF ( k > nzt-1 )  THEN                                         
-                   k_pp = nzt+1                                                
-                ELSE                                                           
-                   k_pp = k + 2                                                
-                ENDIF                                                          
-                IF ( k > nzt-2 )  THEN                                         
-                   k_ppp = nzt+1                                               
-                ELSE                                                           
-                   k_ppp = k + 3                                               
-                ENDIF                                                          
-                                                                               
-                flag_set = .FALSE.                                             
-                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),1)       .AND.     &
-                             BTEST(wall_flags_total_0(k,j,i),1)         .AND.     &
-                             BTEST(wall_flags_total_0(k+1,j,i),1) )     .OR.      &
-                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),1)      .AND.     &                              
-                             BTEST(wall_flags_total_0(k+1,j,i),1)       .AND.     &
-                             BTEST(wall_flags_total_0(k,j,i),1) )       .OR.      &
-                     ( k == nzt .AND. symmetry_flag == 0 ) )                      &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 6 )       
-                   flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),1)    .OR.    &
-                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),1) ) .AND.   & 
-                                 BTEST(wall_flags_total_0(k-1,j,i),1)     .AND.   &
-                                 BTEST(wall_flags_total_0(k,j,i),1)       .AND.   &
-                                 BTEST(wall_flags_total_0(k+1,j,i),1)     .AND.   &
-                                 BTEST(wall_flags_total_0(k_pp,j,i),1)    .AND.   &
-                           .NOT. flag_set                                  .OR.   & 
-                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )              &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 7 )       
-                   flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),1)            .AND.   &
-                         BTEST(wall_flags_total_0(k-1,j,i),1)             .AND.   &
-                         BTEST(wall_flags_total_0(k,j,i),1)               .AND.   &
-                         BTEST(wall_flags_total_0(k+1,j,i),1)             .AND.   &
-                         BTEST(wall_flags_total_0(k_pp,j,i),1)            .AND.   &
-                         BTEST(wall_flags_total_0(k_ppp,j,i),1)           .AND.   &
-                         .NOT. flag_set )                                         &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 5 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )
+                ENDIF
+!
+!--             u component - z-direction. Fluxes are calculated on w-grid
+!--             level. Boundary u-values at/within walls aren't used.
+!--             WS1 (6), WS3 (7), WS5 (8)
+                IF ( k == nzb+1 )  THEN
+                   k_mm = nzb
+                ELSE
+                   k_mm = k - 2
+                ENDIF
+                IF ( k > nzt-1 )  THEN
+                   k_pp = nzt+1
+                ELSE
+                   k_pp = k + 2
+                ENDIF
+                IF ( k > nzt-2 )  THEN
+                   k_ppp = nzt+1
+                ELSE
+                   k_ppp = k + 3
+                ENDIF
+
+                flag_set = .FALSE.
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),1)       .AND.  &
+                             BTEST(wall_flags_total_0(k,j,i),1)         .AND.  &
+                             BTEST(wall_flags_total_0(k+1,j,i),1) )     .OR.   &
+                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),1)      .AND.  &
+                             BTEST(wall_flags_total_0(k+1,j,i),1)       .AND.  &
+                             BTEST(wall_flags_total_0(k,j,i),1) )       .OR.   &
+                     ( k == nzt .AND. symmetry_flag == 0 ) )                   &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 6 )
+                   flag_set = .TRUE.
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),1)    .OR. &
+                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),1) ) .AND.&
+                                 BTEST(wall_flags_total_0(k-1,j,i),1)     .AND.&
+                                 BTEST(wall_flags_total_0(k,j,i),1)       .AND.&
+                                 BTEST(wall_flags_total_0(k+1,j,i),1)     .AND.&
+                                 BTEST(wall_flags_total_0(k_pp,j,i),1)    .AND.&
+                           .NOT. flag_set                                  .OR.&
+                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )           &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 7 )
+                   flag_set = .TRUE.
+                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),1)            .AND.&
+                         BTEST(wall_flags_total_0(k-1,j,i),1)             .AND.&
+                         BTEST(wall_flags_total_0(k,j,i),1)               .AND.&
+                         BTEST(wall_flags_total_0(k+1,j,i),1)             .AND.&
+                         BTEST(wall_flags_total_0(k_pp,j,i),1)            .AND.&
+                         BTEST(wall_flags_total_0(k_ppp,j,i),1)           .AND.&
+                         .NOT. flag_set )                                      &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 8 )
@@ -570,6 +575,6 @@
              DO  k = nzb+1, nzt
 !
-!--             At first, set flags to WS1. 
-!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!--             At first, set flags to WS1.
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to
 !--             in order to handle the left/south flux.
                 advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 9  )
@@ -583,8 +588,8 @@
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
                            .AND. i == nxr   ) )                                &
-               THEN                                                            
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 9 )       
-!                                                                              
-!--             WS3                                                            
+               THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 9 )
+!
+!--             WS3
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),2)   .AND.  &
                                  BTEST(wall_flags_total_0(k,j,i+1),2) ) .OR.   &
@@ -595,21 +600,21 @@
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i == nxlu  ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 10 )      
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )     
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 10 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )
                 ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),2)  .AND.           &
                          BTEST(wall_flags_total_0(k,j,i+2),2)  .AND.           &
                          BTEST(wall_flags_total_0(k,j,i-1),2) )                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 11 )      
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )       
-                ENDIF                                                          
-!                                                                              
-!--             v component - y-direction                                      
-!--             WS1 (12), WS3 (13), WS5 (14)                                   
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 11 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )
+                ENDIF
+!
+!--             v component - y-direction
+!--             WS1 (12), WS3 (13), WS5 (14)
                 IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),2) .OR.           &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
